define({"0":{y:0,u:"../Content/P4Java/about.p4java.html",l:-1,t:"How to use this guide | P4Java",i:0.0292283712402,a:"How to use this guide This section provides  navigation tips and  information on typographical conventions, feedback options, and additional documentation. Navigation Use following controls to navigate the content in this manual: The arrow buttons   and   at the top of any page bring you to the next ..."},"1":{y:0,u:"../Content/P4Java/chapter.p4java.html",l:-1,t:"P4Java Programming",i:0.0292283712402,a:"P4Java is a Java API developed by Perforce that enables applications to access\nHelix Server,      the Perforce\n      enterprise version control system in a “Java natural” and Java-native\n      way. P4Java presents\n      Helix Server\n      services and\n      managed\n      resources and files as ..."},"2":{y:0,u:"../Content/P4Java/p4java.requirements.html",l:-1,t:"System Requirements",i:0.0292283712402,a:"P4Java requires Java 11 or later. Due to current US export control restrictions for some countries, the\n      standard JDK package only comes with 128 bit encryption level cyphers. In\n      order to use P4Java to connect to an SSL-enabled\n      Helix Server, those living in eligible countries may ..."},"3":{y:0,u:"../Content/P4Java/p4java.installation.html",l:-1,t:"Installation",i:0.0292283712402,a:"Download the P4Java ZIP file from the\n      Perforce\n      web site, see  https://www.perforce.com/downloads/helix-core-api-java . Extract the enclosed JARs and other files to a temporary\n      directory, then install the p4java.jar JAR file into a\n      location that is suitable for use by ..."},"4":{y:0,u:"../Content/P4Java/p4java.documentation.html",l:-1,t:"Documentation",i:0.0292283712402,a:"Documentation Included with the P4Java ZIP file is a directory of documentation that\n      contains this document and a full Javadoc document set for all public\n      interfaces and classes. The Javadoc document set can be found at: P4Java API Javadoc"},"5":{y:0,u:"../Content/P4Java/p4java.samples.html",l:-1,t:"Sample programs",i:0.0292283712402,a:"Sample P4Java applications are available on\n             \n      GitHub in the Perforce area, see  https://github.com/perforce/p4java-examples . These samples are used throughout this document to illustrate common\n      usage patterns and simple code snippets, and can also be used as the\n      basis ..."},"6":{y:0,u:"../Content/P4Java/p4java.packages.html",l:-1,t:"Java package roadmap",i:0.0292283712402,a:"The P4Java API contains the following main public packages: com.perforce.p4java: the main p4java\n\tpackage hierarchy root. Contains a small handful of API-wide\n\tdefinitions and classes for activities like logging, tracing, and\n\tpackage metadata. com.perforce.p4java.server: contains the server factory ..."},"7":{y:0,u:"../Content/P4Java/p4java.basic.html",l:-1,t:"Basic P4Java usage model",i:0.0292283712402,a:"The following basic model for P4Java reflects typical\n      Helix Server\n      usage: A Java application uses the P4Java ServerFactory class\n\tto obtain an IOptionsServer interface onto a specific Helix Server at a known network address and port, and connects to this Helix Server through the ..."},"8":{y:0,u:"../Content/P4Java/p4java.typical.html",l:-1,t:"Typical usage patterns",i:0.0292283712402,a:"This section briefly describes typical usage patterns and provides a\n      starting point for developers using P4Java for the first time. Many\n      examples below are snippets from (or refer to) the P4Java sample programs available on\n             \n      GitHub in the Perforce area, see  ..."},"9":{y:0,u:"../Content/P4Java/p4java.typical.interfaces.html",l:-1,t:"The IOptionsServer and IClient interfaces and\n      the ServerFactory class",i:0.0292283712402,a:"The com.perforce.p4java.server.IOptionsServer interface represents\n      a specific Helix Server in the P4Java API, with methods to access typical Helix Server services. Each instance of a IOptionsServer interface is\n      associated with a Helix Server running at a specified location (network ..."},"10":{y:0,u:"../Content/P4Java/p4java.typical.exceptions.html",l:-1,t:"Exception and error handling",i:0.0375097430223257,a:"P4Java uses a small set of Java exceptions to signal errors that have\n      occurred in either the Helix Server as a result of issuing a specific command to the server, or in the\n      P4Java plumbing in response to things like TCP/IP connection errors or\n      system configuration issues. (These ..."},"11":{y:0,u:"../Content/P4Java/p4java.typical.fileio.html",l:-1,t:"Helix Server file operations",i:0.0693930226942814,a:"To define common\n      Helix Server-managed\n      file attributes and options, P4Java uses the\n      com.perforce.p4java.core.file.IFileSpec interface.\n      Attributes like revisions, dates, actions, and so on, are also defined in\n      the core.file package, along with some key helper classes\n     ..."},"12":{y:0,u:"../Content/P4Java/p4java.typical.summaryvsfull.html",l:-1,t:"Summary vs. Full Objects",i:0.0292283712402,a:"The 2009.2 release of P4Java introduced the notion of “summary” and\n      “full” representations of objects on a Helix Server. In many cases, the Helix Server only returns summaries of objects that it’s been asked to list.\n      For example, if you issue a  p4 clients command to a\n      server, what ..."},"13":{y:0,u:"../Content/P4Java/p4java.typical.option.classes.html",l:-1,t:"Using option classes",i:0.0292283712402,a:"This section shows some common usage patterns you can use when coding with P4Java.  Server options There are a variety of properties you can set for your Perforce P4Java application when acquiring an  IOptionsServer object. Setting your application\u0027s program name and version: Setting your program ..."},"14":{y:0,u:"../Content/P4Java/p4java.advanced.html",l:-1,t:"Advanced usage notes",i:0.0292283712402,a:"Advanced usage notes The following notes provide guidelines for developers using features\n      beyond the basic usage model."},"15":{y:0,u:"../Content/P4Java/p4java.advanced.server.html",l:-1,t:"Helix Server addresses, URIs, and properties",i:0.0292283712402,a:"P4Java uses a URI string format to specify the network location of\n      target Helix Servers. This URI string format is described in detail in the server\n      factory documentation, but it always includes at least the server’s\n      hostname and port number, and a scheme part that indicates a ..."},"16":{y:0,u:"../Content/P4Java/p4java.advanced.ssl.html",l:-1,t:"SSL connection support",i:0.0292283712402,a:"Helix Server\n      at release 2012.1 or higher supports 256-bit SSL connections and trust\n      establishment by accepting the fingerprint of the SSL certificate’s\n      public key. Due to current US export control restrictions for some countries, the\n      standard JDK package only comes with 128 ..."},"17":{y:0,u:"../Content/P4Java/p4java.advanced.iserverresource.html",l:-1,t:"The IServerResource interface",i:0.0292283712402,a:"P4Java represents Helix Server objects (such as changelists, branch mappings, job specs, and so\n      on) to the end user through associated interfaces (such as\n      IChangelist, IBranchSpec, and so on) onto\n      objects within P4Java that mirror or proxy the server-side originals.\n      This ..."},"18":{y:0,u:"../Content/P4Java/p4java.advanced.properties.html",l:-1,t:"P4Java properties",i:0.0540724865865772,a:"P4Java uses Java properties to set various operational values for\n      specific IOptionsServer instances and/or for P4Java as a whole.\n      These properties are typically used for things like preferred temporary\n      file directory locations, application version and name information for Helix ..."},"19":{y:0,u:"../Content/P4Java/p4java.advanced.charset.html",l:-1,t:"Character Set Support",i:0.0540724865865772,a:"Character set support is only enabled for Unicode-enabled Helix Servers. In this mode, P4Java differentiates between\n      Helix Server\n      file content character sets (that is, the encoding used to read or write\n      a file’s contents) and the character sets used for\n      Helix Server\n      ..."},"20":{y:0,u:"../Content/P4Java/p4java.advanced.errors.html",l:-1,t:"Error Message Localization",i:0.0292283712402,a:"Error messages originating from the Helix Server are localized if the Helix Server is localized; error messages originating in P4Java itself are not\n      currently localized. P4Java’s internal error messages aren’t intended for\n      end-user consumption as-is; your applications should process such ..."},"21":{y:0,u:"../Content/P4Java/p4java.advanced.logging.html",l:-1,t:"Logging and tracing",i:0.0292283712402,a:"P4Java includes a simple logging callback feature, documented in the\n      ILogCallback Javadoc page, that enables consumers to log\n      P4Java-internal errors, warnings, informational messages, exceptions, and\n      so on. Logging is enabled or disabled on a P4Java-wide basis, not on a\n      ..."},"22":{y:0,u:"../Content/P4Java/p4java.advanced.standard_classes.html",l:-1,t:"Standard implementation\n      classes",i:0.0292283712402,a:"The com.perforce.p4java.impl.generic package is the root\n      for a fairly large set of standard implementation classes such as\n      Job, Changelist, and so on. These\n      implementation classes are used internally by P4Java, and\n      while usage is not mandatory, you are encouraged to use them ..."},"23":{y:0,u:"../Content/P4Java/p4java.advanced.metadata.html",l:-1,t:"I/O and file metadata issues",i:0.0292283712402,a:"The quality of P4Java’s network and file I/O in real-world usage is\n      strongly affected by the quality of implementation of the underlying Java\n      NIO packages. Java’s handling of file metadata also affects I/O. Although\n      JDK 6 is an improvement over JDK 5, it can be difficult to ..."},"24":{y:0,u:"../Content/P4Java/p4java.advanced.threading.html",l:-1,t:"Threading issues",i:0.0375097430223257,a:"P4Java is inherently thread-safe when used properly. The following best\n      practices can help to ensure that users do not encounter thread-related\n      problems: P4Java’s IOptionsServer object is partially thread-safe. The\n\tonly state preserved in the underlying implementation classes is ..."},"25":{y:0,u:"../Content/P4Java/p4java.advanced.authentication.html",l:-1,t:"Authentication",i:0.0751899795633127,a:"P4Java implements both the\n      Helix Server\n      tickets-based authentication and the\n      Helix Server\n      single sign on (SSO) feature. Both types of authentication are described\n      in detail in the P4Java Javadoc, but some P4Java-specific issues to note\n      include: P4Java manages a  ..."},"26":{y:0,u:"../Content/P4Java/p4java.advanced.notes.html",l:-1,t:"Other Notes",i:0.0292283712402,a:"As documented in the main\n\tHelix Server\n\tdocumentation,\n\tHelix Server\n\tform triggers can cause additional output on form commands such as\n\t“change” or “client”, even when the trigger succeeds. This trigger\n\toutput is available through the P4Java command callback feature, but\n\tnote that there is ..."},"27":{y:0,u:"../Content/Shared/glossary.html",l:-1,t:"Glossary",i:0.0292283712402,a:"Glossary"},"28":{y:0,u:"../Content/P4Java/license.statements.html",l:-1,t:"License Statements",i:0.0292283712402,a:"License Statements For licensing information for P4Java and the third-party software included in this Perforce product, see the P4Java License file . "},});